<?php

namespace Drupal\commerce_vnpay_payment\Plugin\Commerce\PaymentGateway;

use Drupal\commerce_order\Entity\OrderInterface;
use Drupal\commerce_payment\Entity\PaymentInterface;

/**
 * An interface for VNPayOffsite.
 */
interface VNPayOffsiteInterface {

  /**
   * Get return page url.
   *
   * @param \Drupal\commerce_order\Entity\OrderInterface $order
   *   The order of payment.
   *
   * @return \Drupal\Core\Url
   *   The return URL after payment successfully.
   */
  public function getReturnUrl(OrderInterface $order);

  /**
   * Create new payment and get payUrl from MoMo API.
   *
   * @param \Drupal\commerce_payment\Entity\PaymentInterface $payment
   *   The payment.
   *
   * @return string|null
   *   The url string or null if the condition is not satisfied.
   */
  public function getPayUrl(PaymentInterface $payment);

  /**
   * Get order information.
   *
   * @param \Drupal\commerce_order\Entity\OrderInterface $order
   *   The order of payment.
   *
   * @return string
   *   The information of order after processing.
   */
  public function getOrderInfo(OrderInterface $order);

}
